#!/usr/bin/perl

#
##            NEW UBB SCRIPT by Obed Fernandez              ##
#                obed.fernandez@bigfoot.com
#                   January 4, 2000
#
#       ------------ newsdisplay.cgi -------------
#         based on forumdisplay.cgi of UBB v5.40
#
#  This file contains the functionality for the UBB
#  individual forum page display in a news article layout.
#  The latest new topic is always shown as the default
#  article on the news forum thread listing. The other
#  topics, 10 hardcoded, are displayed in a column on the
#  right side of the page. Clicking on those links displays
#  the topic in the article slot. Articles have a link at
#  bottom of them linking to the normal UBB HTML file to
#  readers to view/add replies.
#
###h Comments: Stripped a lot of the private forum stuff since
#    the news will always be public.
###############################################################
#


## NOTICE THE HARDCODED TITLE - PLEASE CHANGE
$mySpecialNewsForumTitle = "True Authority News";
$myNumberOfArticlesToList = 10;

## PLEASE NOTE: sub PageBottomHTML also has some hardcoded values which you want
## to definitely change -- approx line 609

#If you are running UBB on IIS,
#you may need to add the following line
#if so, just remove the "#" sign before the print line below
#print "HTTP/1.0 200 OK\n";
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file

require "UltBB.setup";
require "Date.pl";
require "mods.file";
require "ubb_library.pl";

};

print ("Content-type: text/html\n\n");

&ReadParse;

foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	if ($Name eq "forum") {
		$Forum = $Value;
		$Forum =~ s/\/\\//g;
		$ForumCoded = &HTMLIFY($Forum);
		$ForumCoded =~ tr/ /+/;
		$Forum = &UNHTMLIFY($Forum);
	}
	if ($Name eq "UserName") {
		$UserName = $Value;
		$UserNameFile = $UserName;
		$UserNameFile =~ s/ /_/g; #remove spaces
	}
	if ($Name eq "BypassCookie") {
		$BypassCookie = $Value;
	}
	if ($Name eq "category") {
		$category = $Value;
		$CategoryName = &GetCatName($category);
	}
	if ($Name eq "PasswordConfirm") {
		$PasswordConfirm = $Value;
	}
	if ($Name eq "number") {
		$number = $Value;
	}
	if ($Name eq "DaysPrune") {
		$DaysPrune = $Value;
	}
	if ($Name eq "topic") {
		$topic = $Value;
	}

	if ($Name eq "Email") {
		$Email = $Value;
		$Email =~tr/A-Z/a-z/; 
	}
	if ($Name eq "URL") {
		$URL = &CleanThis($Value);
		$URL = &PipeCleaner($URL);
	}
	if ($Name eq "Permissions") {
		$Permissions = $Value;
	}
	if ($Name eq "Congregation") {
		$Congregation = &CleanThis($Value);
		$Congregation = &PipeCleaner($Congregation);
	}
	if ($Name eq "Location") {
		$Location = &CleanThis($Value);
		$Location = &PipeCleaner($Location);
	}
	if ($Name eq "TotalPosts") {
		$TotalPosts = $Value;
	}
	if ($Name eq "Status") {
		$Status = $Value;
	}
	if ($Name eq "Interests") {
		$Interests = &CleanThis($Value);
		$Interests = &PipeCleaner($Value);
	}
	if ($Name eq "sendto") {
		$sendto = $Value;
	}
}  # end FOREACH $row

if ($VariablesPath eq "") {
	$VariablesPath = $CGIPath;
}

if (-e "$ForumsPath/Forum$number/forumstyles.file") {
require "$ForumsPath/Forum$number/forumstyles.file";
}  else {
require "$VariablesPath/Styles.file";
}

$SearchOption = qq(<A HREF="$CGIURL/search.cgi?action=intro&default=$number"><ACRONYM TITLE="Perform a search by keyword, date, or name.">Search the news articles</ACRONYM></A>);

#adjust bgcolor variables
if ($BGColor ne ""){
$BGColor = qq(bgcolor="$BGColor");
}
if ($AltColumnColor1 ne ""){
$AltColumnColor1 = qq(bgcolor="$AltColumnColor1");
}
if ($AltColumnColor2 ne ""){
$AltColumnColor2 = qq(bgcolor="$AltColumnColor2");
}
if ($CategoryStripColor ne ""){
$CategoryStripColor = qq(bgcolor="$CategoryStripColor");
}
if ($TableColorStrip ne ""){
$TableColorStrip = qq(bgcolor="$TableColorStrip");
}
if ($PageBackground ne ""){
$PageBackground = qq(background="$NonCGIURL/$PageBackground");
}

## I don't recommend border color use - try it and see
if ($TableBorderColor ne ""){
$TableWidth2 = "100%";
$BorderTop = qq(<table border=0 cellpadding=0 cellspacing=0 width="$TableWidth"><TR><td bgcolor="$TableBorderColor">);
$BorderBottom = qq(</td></tr></table> );
}  else {
$TableWidth2 = $TableWidth;
$BorderTop = "";
$BorderBottom = "";
}


if ($BBStatus eq "OFF") {
&StandardHTML("Sorry, this bulletin board is temporarily unavailable, while we perform some routine maintenance.  Please try back again later.  Feel free to email us at <A HREF=\"mailto:$BBEmail\">$BBEmail</A>.");
exit;
}

&Topics;
exit;


sub Topics {

if ($number eq "") {
	&StandardHTML("You did not select a specific forum or archive.");
	exit;
}

&get_cookie;  #retrieves all current cookies
	$SessionLogin = "$cookie{sessionLogin}";
	$SessionLoginDT = "$cookie{sessionLoginDT}";

@thisforum = &GetForumRecord($number);


if ($thisforum[8] eq "") {
&StandardHTML("We could not find that forum or archive.  Please go back and try again.");
exit;
}
$category = $thisforum[0];
$CategoryName = &GetCatName($category);
$ForumPW = $thisforum[12];

$LWA = $thisforum[6]; 

if ($LWA eq "private") {
	$ReplyRestrict = "restrict";
	$TopicRestrict = "restrict";
}  else {
($TopicRestrict, $ReplyRestrict) = split("&", $LWA);
}

$Moderator = ("Forum" . "$number" . "Moderator");
$Moderator = $$Moderator;
#split up Mod var
@mods = split(/\|\|\^\|\|/, $Moderator);


$DIRPW = "";
$ExactPath = "Forum$number";

if ($DaysPrune eq "") {
$DaysPrune = "$cookie{DaysPrune}";
}
if ($DaysPrune eq "") {
$DaysPrune = 30;
}


$Forum = $thisforum[1];
$CustomTitle = $thisforum[9];
chomp($CustomTitle);
if ($CustomTitle eq "") {
$CustomTitle = "$BBTitle";
}

# changed text to use of the word reporter
if ($TopicRestrict eq "restrict") {
	$TopicLegend = "<B>New Topics:</B> Only authorized reporters may post new articles in this forum. Click here for information on becoming a reporter.";
}
elsif ($TopicRestrict eq "allreg") {
	$TopicLegend = "<B>New Topics:</B> All registered users may post new topics in this forum.";
}  else {
	$TopicLegend = "<B>New Topics:</B> Any visitors (including unregistered) may post new topics in this forum.";
}

if ($ReplyRestrict eq "restrict") {
	$ReplyLegend = "<B>Replies:</B> Only authorized users may post replies to topics in this forum.";
}
elsif ($ReplyRestrict eq "allreg") {
	$ReplyLegend = "<B>Replies:</B> All registered users may post replies to articles.";
}
elsif ($ReplyRestrict eq "all") {
	$ReplyLegend = "<B>Replies:</B> Any visitors (including unregistered) may post replies in this forum.";
}  else {
	$ReplyLegend = "<B>Replies:</B> No replies are permitted in this forum.";
}

$ForumCoded = &HTMLIFY($Forum);
$ForumCoded =~ tr/ /+/;

foreach $unomod(@mods) {
chomp($unomod);
$ModNumber = &GetUserNumber($unomod);
if ($ModNumber ne "") {
@theprofile = &OpenProfile("$ModNumber.cgi");
$ModeratorEmail = "$theprofile[2]";
if ($ModeratorLine ne "") {
$ModeratorLine .= qq(, <A HREF="mailto:$ModeratorEmail">$unomod</A>);
}  else {
$ModeratorLine = qq(<A HREF="mailto:$ModeratorEmail">$unomod</A>);
}
} 

}

&TopicTopHTML;

&CurrentDate; 

if ($DaysPrune eq "1000") {
$DPJulian = 0;
}  else {
$DPJulian = $CurrentJulian - $DaysPrune;
}

##### create new threads summary file, if necessary
unless (-e "$ForumsPath/$ExactPath/forum$number.threads") {
my $CreateThreadFile = "yes";
&ForumSummary($number);
}  # end UNLESS THREADS SUMMARY EXISTS
##########

if ($CreateThreadFile ne "yes") {
#open thread file online
@thefinalarray = &OpenFile("$ForumsPath/$ExactPath/forum$number.threads");
}

$TotalTopics = @thefinalarray;
#open last number file
@foruminfo = &OpenFile("$ForumsPath/$ExactPath/lastnumber.file");
chomp($foruminfo[1]);
$LastNumberVerify = $foruminfo[1] + 0;

if ($TotalTopics != $LastNumberVerify) {
&SetThreadInfo;
&ForumSummary($number);
@sortfinalarray = sort(@finalarray);
} else {
@sortfinalarray = sort(@thefinalarray);
}
@finalarray = reverse(@sortfinalarray);
## @finalarray hold thread summary used to display page

$x = $number;
#set Days Prune variable to 3 digits for matching--

if ($DaysPrune == 1) {
	$Days1 = "SELECTED";
}
elsif ($DaysPrune == 2) {
	$Days2 = "SELECTED";
}
elsif ($DaysPrune == 5) {
	$Days5 = "SELECTED";
}
elsif ($DaysPrune == 10) {
	$Days10 = "SELECTED";
}
elsif ($DaysPrune == 20) {
	$Days20 = "SELECTED";
}
elsif ($DaysPrune == 30) {
	$Days30 = "SELECTED";
}
elsif ($DaysPrune == 45) {
	$Days45 = "SELECTED";
}
elsif ($DaysPrune == 60) {
	$Days60 = "SELECTED";
}
elsif ($DaysPrune == 75) {
	$Days75 = "SELECTED";
}
elsif ($DaysPrune == 100) {
	$Days100 = "SELECTED";
}
elsif ($DaysPrune == 1000) {
	$Days1000 = "SELECTED";
}  else {
	$Days365 = "SELECTED";
}

$Count = 0;

CHECKEACH: for $eachone(@finalarray) {
	chomp($eachone);
	@threadinfo2 = split(/\|\^\|/, $eachone);
	if ($threadinfo2[2] eq "") {
	next CHECKEACH;
	}
	$PostDateJulian2 = $threadinfo2[0];
	($PostDateJulian, $junk) = split(/\./, $PostDateJulian2);
	
	#do date compare on post julian

	if ($PostDateJulian >= $DPJulian) {
	push(@goodarray2, $eachone);
	}  else {
	last CHECKEACH;
	}
}  #foreach eachone

$TotalGood2 = @goodarray2;
$TotalGood = $TotalGood2 - 1;

#check to see if we need to truncate this list
$ForumDisplayMax = $myNumberOfArticlesToList;
unless (($ForumDisplayMax eq "") || ($ForumDisplayMax eq "NONE")) {

$Sections = $TotalGood2 / $ForumDisplayMax;
$Sections = "$Sections";

if ($Sections =~ /\./) {
	($Whole, $junk) = split(/\./, $Sections);
	$Sections = $Whole;
}  else {
	$Sections = $Sections - 1;
}

if ($in{'startpoint'} eq "") {
	$StartPoint = 0;
	$ArrayStop = $ForumDisplayMax - 1;
	if ($TotalGood <= $ArrayStop) {
		$MoreTopicsWording = "";
		$ArrayStop = $TotalGood;
	}  else {
		for ($Section = 0;  $Section <= $Sections; $Section++) {
			$Starting = $Section * $ForumDisplayMax;
			
			$Block = $Section + 1;
			if ($Block == 1) {
			$MoreTopicsWording .= qq($Block );
			}  else {
			$MoreTopicsWording .= qq(<A HREF="$CGIURL/newsdisplay.cgi?action=topics&number=$number&forum=$ForumCoded&DaysPrune=$DaysPrune&startpoint=$Starting">$Block</a> );
			}
		}
	}
}  else {
	$StartPoint = $in{'startpoint'};
	$ArrayStop = $StartPoint + $ForumDisplayMax;
	$ArrayStop--;
	if ($TotalGood <= $ArrayStop) {
		$ArrayStop = $TotalGood;
	}  
	for ($Section = 0;  $Section <= $Sections; $Section++) {
			$Starting = $Section * $ForumDisplayMax;
		
			$Block = $Section + 1;
			if ($StartPoint == $Starting) {
			$MoreTopicsWording .= qq($Block );
			}  else {
			$MoreTopicsWording .= qq(<A HREF="$CGIURL/newsdisplay.cgi?action=topics&number=$number&forum=$ForumCoded&DaysPrune=$DaysPrune&startpoint=$Starting">$Block</a> );
			}
		}
}

# slight modification 
if ($MoreTopicsWording ne "") {
$MoreTopicsW = ("Pages Found: $MoreTopicsWording");
}

&TopicMidHTML;

@truncate = @goodarray2[$StartPoint... $ArrayStop];
@goodarray3 = sort(@truncate);
@goodarray2 = reverse(@goodarray3);
}

foreach $goodie(@goodarray2) {
	chomp($goodie);
	@threadinfo = split(/\|\^\|/, $goodie);
	$ClosedItem = $threadinfo[6];
	chomp($ClosedItem);
	#format date
	$ThisYear = substr($threadinfo[5], 0, 4);
	$ThisMonth = substr($threadinfo[5], 4, 2);
	$ThisDay = substr($threadinfo[5], 6, 2);
	$hour = substr($threadinfo[5], 8, 2);
	$min = substr($threadinfo[5], 10, 2);
	$HyphenIt = "$ThisMonth-$ThisDay-$ThisYear";
		
	if ($DateFormat eq "US") {
		$TheDate = "$ThisMonth-$ThisDay-$ThisYear";
		$DateWording = "All dates are in Month-Day-Year format.";
		$DateSize = "2";
	}
	elsif ($DateFormat eq "Euro") {
		$TheDate = "$ThisDay-$ThisMonth-$ThisYear";
		$DateWording = "All dates are in Day-Month-Year format.";
		$DateSize = "2";
	}
	elsif ($DateFormat eq "USX") {
		$TheDate = &DateFormat("$HyphenIt", "USExpanded");
		$DateSize = "1";
	} else {
		$TheDate = &DateFormat("$HyphenIt", "EuroExpanded");
		$DateSize = "1";
	}
		
	$TopicJulianDT = $threadinfo[0];

	#format time option 1
	if ($TimeFormat eq "24HR")  {
		$FormatTime = "$hour:$min";
	}
	&NormalTime;

	#format time option 2
	if ($TimeFormat eq "AMPM")  {
		$FormatTime = "$hour:$min $AMPM";
	}

# takes the place of the normal forumdisplay.cgi HTMLGuts
&ArticleListItem;

} #end foreach goodarray
print $MoreTopicsW;
&TopicBottomHTML;
&GetForumSelectList;

if ($SessionLogin ne "") {
&TopicBottom2JShtml;
}  else {
&TopicBottom2NonJShtml;
}

}  ## END TOPICS SR ####


# HTML SUBROUTINES ASSOCIATED WITH THE
# FORUM PAGE DISPLAY ARE LISTED BELOW---

sub TopicTopHTML {


&GetCookieInfo;
if ($SetCookies eq "DirectorySpecific") {
	$ExtraInfo = qq(domain=$TheDomain;path=/$ThePath;);
}  else {
	$ExtraInfo = "";
}

print <<TOP;
<HTML>
<HEAD><TITLE>$mySpecialNewsForumTitle</title>
$HeaderInsert
</head>
<BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor">
<FONT SIZE="$TextSize" FACE="$FontFace">
$Header
TOP
}  ## END TOPIC TOP HTML sr

sub TopicMidHTML {

## more semantics changes: Editor instead of Moderator
## articles instead of threads

print <<OtherMiddle;
<center>
<table border=0 width=$TableWidth cellpadding=5>
<tr>
<td align=left valign=top>
<IMG SRC="$NonCGIURL/$CustomTitle" BORDER=0>
<BR>
<small>Editor(s): $ModeratorLine
</td>
<td valign=bottom align=right>
<FONT FACE="$FontFace" size="2">$ForumBody
<p><FORM ACTION="newsdisplay.cgi" METHOD="GET">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="topics">
<INPUT TYPE="HIDDEN" NAME="forum" VALUE="$Forum">
<INPUT TYPE="HIDDEN" NAME="number" VALUE="$number">
<SELECT NAME="DaysPrune">
        <OPTION value="1" $Days1>Show articles from last day
        <OPTION value="2" $Days2>Show articles from last 2 days
        <OPTION value="5" $Days5>Show articles from last 5 days
        <OPTION value="10" $Days10>Show articles from last 10 days
        <OPTION value="20" $Days20>Show articles from last 20 days
        <OPTION value="30" $Days30>Show articles from last 30 days
        <OPTION value="45" $Days45>Show articles from last 45 days
        <OPTION value="60" $Days60>Show articles from last 60 days
        <OPTION value="75" $Days75>Show articles from last 75 days
        <OPTION value="100" $Days100>Show articles from last 100 days
        <OPTION value="365" $Days365>Show articles from the last year
        <OPTION value="1000" $Days1000>Show all articles
</SELECT>&nbsp;<INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Go"></FORM>
<p>$SearchOption
</td></tr></table>
$BorderTop
<table border=1 cellpadding=8 cellspacing=1 width=$TableWidth2 $AltColumnColor1 bordercolorlight="$TableBorderColor"
bordercolor="$AltColumnColor1" bordercolordark="$TableBorderColor">
<tr $TableColorStrip>
<td $TableColorStrip>
<FONT SIZE="2" $FontFace" color="$TableStripTextColor"><B>Featured Article</B>
</td>
<td>
<FONT SIZE="2" $FontFace" color="$TableStripTextColor"><b>News</b><B>$MoreTopicsW</B>
</td></tr>
<tr><td valign=top>
OtherMiddle
&LatestArticle;
print qq(</td><td width=300 valign=top><FONT SIZE="1" $FontFace">);
}  ## END Middle HTML for Topic Page 


sub LatestArticle {

## the name of the sub is kinda misleading -- it does the latest
## article by default, but also grabs the selected article when a
## user clicks on it from the right column. Notice new parameter
## $in{'article'}

if ($in{'article'} ne "") {
	$showfile = $in{'article'};
} else {
	chomp($foruminfo[0]);
	$showfile = $foruminfo[0];
}

## used the ubb_library instead of opening it myself
my @thisfile = &OpenFile("$ForumsPath/$ExactPath/$showfile.cgi");
## first line of the forum.file
my @header = split(/\|\|/,$thisfile[0]);
## second line of the forum.file
my @body = split(/\|\|/,$thisfile[1]);

## the article format - modify to suit your tastes; add dates, etc
print <<ENDLATEST
<FONT FACE="$FontFace"><h2>$header[4]</h2>
<h3>by $header[3]</h3>
<font size=2>$body[6]
<h3><small><small><a href="$NonCGIURL/$ExactPath/HTML/$showfile.html">Click here to read replies or post your own...</a></small></small></h3>
ENDLATEST
}  ## END LatestArticle SR

## modified to call itself rather than the HTML file
## notice the <HR noshade size=1> as per CNN.com style
sub ArticleListItem {
print qq(<A HREF="$CGIURL/newsdisplay.cgi?action=topics&number=$number&forum=$ForumCoded&DaysPrune=$DaysPrune&article=$threadinfo[1]&startpoint=$in{'startpoint'}">$threadinfo[2]</A><br><small>by $threadinfo[4] ($threadinfo[3] replies; last $TheDate $FormatTime)</small><HR noshade size=1>);
} 


sub TopicBottomHTML {
print<<BOTTOM
</td></tr></table>
$BorderBottom
<br>
<table border=0 width=$TableWidth>
<tr><td align=left valign=top>
<FONT SIZE="1" FACE="$FontFace" COLOR="$VisitedLinkColor">All times are $TimeZone. <br><br>$DateWording<br>
<br>All rights reserved.</FONT></td>
<td NOWRAP align=right>
<FONT SIZE="$TextSize" FACE="$FontFace">
<FORM ACTION="forumdisplay.cgi" METHOD="GET">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="topics">
<B>Hop To &nbsp;</B><SELECT NAME="number">
BOTTOM
} ## End TopicBottomNonIEhtml

sub TopicBottom2JShtml {
print<<TrueTopicBottom;
</SELECT><INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Go"></FORM></FONT></TD></tr></TABLE>
<P></center>
<img src="$NonCGIURL/closedb.gif" border=0 alt="No New Posts">&nbsp;&nbsp;Contains new posts since the last time you logged on.<BR>
<img src="$NonCGIURL/closed.gif"  border=0 alt="No New Posts">&nbsp;&nbsp;No new posts since the last time you logged on.<BR>
<IMG SRC="$NonCGIURL/lock.gif" BORDER=0 ALT="Closed Thread">&nbsp;&nbsp;A Closed thread - no new replies accepted.
<p>
<CENTER><A HREF="$CGIURL/postings.cgi?action=newtopic&number=$number&forum=$ForumCoded">Post Article (Reporters only)</A><P>
TrueTopicBottom

&PageBottomHTML;
}

sub TopicBottom2NonJShtml {
print<<TrueTopicBottom;
</SELECT><INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Go"></FORM></FONT></TD></tr></TABLE>
</center>
<p>
<CENTER><A HREF="$CGIURL/postings.cgi?action=newtopic&number=$number&forum=$ForumCoded">Post Article (Reporters only)</A><P>
TrueTopicBottom

&PageBottomHTML;
}



sub ConfirmIdentity {

if ($ForumPW ne "") {
$FPWWording = qq(<TR $AltColumnColor1><TD colspan=2><FONT SIZE="$TextSize" FACE="$FontFace">If you are not an administrator or moderator and have not been given specific permission to access this forum but know the forum password, you must enter the password below in order to gain access.</font></td></tr>
<TR $AltColumnColor2><TD><FONT SIZE="$TextSize" FACE="$FontFace">
Forum Password:</font></td><td><INPUT TYPE="PASSWORD" NAME="ForumPassword" VALUE="" SIZE=12 MAXLENGTH=12></td></tr>);
}  else {
$FPWWording = "";
}

print <<CONFIRM;
<HTML><HEAD>
$HeaderInsert
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
function SetCursor() {
var testUserName = getCookie("UserName");

if (testUserName != null) {  
	document.THEFORM.UserName.value = getCookie("UserName");
document.THEFORM.Password.value = getCookie("Password");
	}  else {
	document.THEFORM.UserName.focus();
}
}
function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length; 
            return unescape(dc.substring(begin, end));  }
}
return null;
}

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</HEAD>
 <BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" onLoad="SetCursor()">
<br><br><center><FONT SIZE="$TextSize" FACE="$FontFace">
P R I V A T E &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; F O R U M</font>
<FORM ACTION="forumdisplay.cgi" NAME="THEFORM" METHOD="POST">
$BorderTop
<table cellpadding=4 cellspacing=1 border=0 width="$TableWidth2">
<tr $TableColorStrip><td colspan=2>
<FONT SIZE="$TextSize" FACE="$FontFace" color="$TableStripTextColor">
<B>You are attempting to access a private forum.  Please identify yourself below.  Note that this identification screen will only be required once per browser session (per private forum, if you are accessing via forum passwords), assuming you allow cookies to be stored.  We will store your private forum access privileges as a cookie (thus, we highly recommend that you do not disable your cookies in your browser!).</b></td></tr>
<TR $AltColumnColor1><TD><FONT SIZE="$TextSize" FACE="$FontFace">
UserName:</font></td><td><INPUT TYPE="TEXT" NAME="UserName" VALUE="" SIZE=20 MAXLENGTH=35></td></tr>

<TR $AltColumnColor2><TD><FONT SIZE="$TextSize" FACE="$FontFace">
Password:</font></td><td><INPUT TYPE="PASSWORD" NAME="Password" VALUE="" SIZE=20 MAXLENGTH=35></td></tr>
$FPWWording
</table>
$BorderBottom
<P>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="idcheck">
<INPUT TYPE="HIDDEN" NAME="forumnumber" VALUE="$in{'number'}">
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Confirm Identity Now">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Clear Fields Above"></CENTER>
</form>

<br><br></font>
</body></html>
CONFIRM

}

sub VerifyID {

##check ID using username set as cookie
$NameFound = "no";
$ProfileNumber = &GetUserNumber($UserNamePrivate);

if ($NumbersPrivate ne "") {
	if ($NumbersPrivate =~ /B/) {
	@CheckAccess = split("B", $NumbersPrivate);
	}  else {
		@CheckAccess = $NumbersPrivate;
	}
	
	CHECKER: foreach $checker(@CheckAccess) {
		chomp($checker);
		if ($checker eq "$number") {
			$ProceedNow = "true";
			last CHECKER;
		}
	}
}  

if ($ProceedNow ne "true") {

	if ($ProfileNumber ne "") {
		$NameFound = "yes";
		} else {
		$NameFound = "no";
	}
	
		@thisprofile = &OpenProfile("$ProfileNumber.cgi");
if ($PasswordPrivate eq "$thisprofile[1]") {
		$Permission = "$thisprofile[4]";
		$Status = $thisprofile[8];
		($GenPerms, $SpecificPerms) = split(/\&/, $Permission);
		
			$Moderator = ("Forum" . "$number" . "Moderator");
$Moderator = $$Moderator;
#split up Mod var
@mods = split(/\|\|\^\|\|/, $Moderator);

$ModMatch = "";
foreach $unomod(@mods) {
if ($unomod eq "$UserNamePrivate") {
	$ModMatch = "true";
}
}
		if (($Status eq "Administrator") || ($ModMatch eq "yes")) {
	  		$ProceedNow = "true";
	   }
		if (($SpecificPerms ne "") && ($ProceedNow ne "true")){
			chomp($specificPerms);
			@accessarray = split(",", $SpecificPerms);
			CHECKARRAY: foreach $uno(@accessarray) {
				if ($uno eq "$number") {
					$ProceedNow = "true";
					last CHECKARRAY;
				}
			}
		}
	}
}

} #end VerifyID



