#!/usr/bin/perl
#################################################
# Script Name	: Forum Rating Script           #
# Author	: JB007 [ q8_bond@yahoo.com ]   #
# Version	: 1.0                           #
# Release 	: 19 - 7 - 2000                 #
# UBB Test V.	: 5.45C                         #
#-----------------------------------------------#
# q8_bond@yahoo.com - Copyright (c) 2000        #
# Feel Free to modify the code but you should   #
# keep the copyright notice here with all other #
# information.                                  #
#################################################
# Require some ubb files
require "UltBB.setup";
require "ubb_library.pl";
require "Styles.file";

#Work with HTML
print "Content-type: text/html\n\n";

# Now Read the Input of the user
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair(@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
	$FORM{$name} =~ tr/+/ /;
}
# Prepare a hash to store some values
%rating_numbers = (0 => "0",
		   1 => "1",
		   2 => "2",
		   3 => "3",
		   4 => "4",
		   5 => "5",
		   6 => "6",
		   7 => "7",
		   8 => "8",
		   9 => "9",
		   10 => "10" );
# Prepare strings
$rating = $rating_numbers{$FORM{'rateselect'}};
$id = $FORM{'id'};
$cookieusername = $FORM{'cookieuser'};
$forumname = $FORM{'forumname'};

if ($cookieusername eq "") {
	&StandardHTML("Sorry, you've to login or register to rate this forum.");
	exit;
}

if ($rating == 0) {
	&StandardHTML("You didn't select any number! try again.");
	exit;
}

# Get user profile number using a subroutine in ubb_library.pl
$profilenumber = &GetUserNumber("$cookieusername");

if ($profilenumber eq "") {
	&StandardHTML("Sorry, no user with that name!");
	exit;
}

if (-e "$MembersPath/v$profilenumber.cgi") {
	@uservotes = &OpenFile("$MembersPath/v$profilenumber.cgi");
		foreach $vote(@uservotes) {
			chomp($vote);
			if ($vote =~ m/Forum$id/) {
				&StandardHTML("Sorry, you've voted for this forum befor , you can not vote for one forum twice.");
				exit;
			}
		}
		
	&AppendFile("$MembersPath/v$profilenumber.cgi", "Forum$id");
}
else {
	&Lock("lock.file");
	open(WRITE, ">$MembersPath/v$profilenumber.cgi") || die("Unable to open member's profile because of this error: $!");
		print WRITE "Forum$id\n";
	close(WRITE);
	&Unlock("lock.file");
	
	chmod(0777, "$MembersPath/v$profilenumber.cgi");
}
	
if (-e "$ForumsPath/Forum$id/rate.file") {
			require "$ForumsPath/Forum$id/rate.file";
			
			$votes = $votes +1;
			$ratings = $ratings + $rating;
			$average = int($ratings / $votes);
			&Lock("lock.file");
			open(WRITE, ">$ForumsPath/Forum$id/rate.file") || die ("Unable to open the file $ForumsPath/Forum$id/rate.file because of this error:<br> $!");
				print WRITE "\$votes = $votes\;\n";
				print WRITE "\$ratings = $ratings\;";
			close(WRITE);
			&Unlock("lock.file");
			chmod(0666, "$ForumsPath/Forum$id/rate.file");
			
			&StandardHTML("Thank you $cookieusername for voting to forum: $forumname .<P>Total Votes: $votes . <P>Average: $average .");
			exit;
		}
		else {
			$votes = 1;
			$ratings = $rating;
			$average = $rating;
			
			&Lock("lock.file");
			open(WRITE, ">$ForumsPath/Forum$id/rate.file") || die ("Unable to open the file $ForumsPath/Forum$id/rate.file because of this error:<br> $!");
				print WRITE "\$votes = $votes\;\n";
				print WRITE "\$ratings = $ratings\;";
			close(WRITE);
			&Unlock("lock.file");
			chmod(0666, "$ForumsPath/Forum$id/rate.file");
			
			&StandardHTML("Thank you $cookieusername for voting to forum: $forumname .<P>Total Votes: $votes . <P>Average: $average .");
			exit;
}
#########################
# Bond .. James Bond    #
#########################		