#!/usr/bin/perl
# 
# You may need to change the server's path to Perl (above)
# A good alternate is  !/usr/local/perl
# Use whatever is at the top of any existing (working) scripts 
# on your server.
#
# Do not change the name of this script as its performance will 
# be adversely affected. However, you may change the extension 
# to ".pl" if ".cgi" is not supported by your server.
#
# To include "warnings" in your reports, simply add  -w  
# after the path to perl at the top of any scripts you're testing.
# 
# TestMy.CGI is a Perl 5 script that tests the syntax of your 
# scripts and presents a report of any errors directly to 
# your browser. You can easily navigate your entire site's 
# directories with its simple point-and-click directory and 
# file table.
# 
# Simply upload this file (as text) to any directory 
# on your domain or in the root. Your server administrator 
# might restrict executables to a cgi or cgi-bin directory, 
# so that's where you'd want to put this file.
# 
# Set the permission to rwxr-xr-x (755).
#
# Open cplinks.html and find:
#
# <A HREF="http://www.yourdomain.com/cgi-bin/cpanel.cgi?action=misc" target="CPMAIN" >Miscellaneous and/or Debugging</A> 
# <HR>
#
# and add below:
#
# <A HREF="http://www.yourdomain.com/cgi-bin/testmy.cgi" target="CPMAIN">Debug Your Scripts</A> 
# <HR>
#
# you may have to play around with this:
#
# $RootDir = "$ENV{'DOCUMENT_ROOT'}";
# depending on where your root is in respect to your cgi-bin directory, this is what I had to do:
# $RootDir = "/home/usr/";
# 
# That's it! Now open your browser and type:
# http://www.mydomain.com/path/testmy.cgi
# (your domain and path go here)
# and follow the simple online prompts.
# 
# TestMy.CGI is freeware and may be distributed only in its
# original form. User runs this application at his/her 
# own risk, assumes all liability, and no warranty as to 
# the suitability or performance of TestMy.CGI for any 
# purpose is not stated nor implied. If you are dissatisfied 
# with TestMy.CGI, please discontinue its use.
#
# You are urged not to link to this script from any public 
# pages on your site as TestMyCGI displays all the paths and 
# documents - even hidden ones - on your site. Public access to 
# TestMy.CGI may compromise the security of your site 
# and/or server.
# 
# This utility is not supported in any way though your feedback 
# and suggestions are appreciated.
# 
# Application and interface is (c)Copyright 2000. 
# All rights reserved worldwide.
# 
# If you like this handy tool, let me know. In my spare 
# time, I will continue to add new features. 
# go to http://www.CraigRichards.com/ for upgrade info as it 
# becomes available.
#
# Feel free to email me at "cgi@CraigRichards.com" with your 
# comments and/or suggestions.
#
##########
# VARIABLES DEFINED

&inParse;

$RootDir = "/home/usr72/cgi-bin/";
$title = "Script Test Results";
$fnt = "<FONT SIZE=2 FACE=\"arial,helvetica,sans-serif\">";
$fnt1 = "<FONT SIZE=1 FACE=\"arial,helvetica,sans-serif\">";
$version = "v.1";
# $c1 = "8C4D99"; # heads & borders
$c1 = "7F007F"; # heads & borders
$c2 = "000000"; # subtle color
$c3 = "EDEDED"; # DIR/FILE table background color
$c4 = "EDEDED"; # instruct/results background color
$c5 = "000000"; # overall interface background color

##########
# CONDITIONAL VARIABLES DEFINED

if (!$t{'run'}) {
 $path = "$ENV{'SCRIPT_NAME'}";
	$t{'testmycgi'} = "$ENV{'SCRIPT_NAME'}";
 $path =~ s/testmy\.cgi//; $path =~ s/testmy\.pl//;
 $title = "How To Use TestMy.CGI";
  &instblock;
  push(@error,"$instructions");
 }
 else {
 $path = "$t{'path'}";
  if ($path !~ /\/$/) {
   $path =~ s/(.*)/$1\//;}
   $path =~ s/\/\//\//;
#   if ($path eq "\/") {undef($path);}
  if (!$t{'test'}) {
  $title = "How To Use TestMy.CGI";
  &instblock;
  push(@error,"$instructions");
  }
  else {
   if (not(-e "$RootDir$path$t{'test'}")) {
   push(@error,"<TR><TD>$fnt <FONT COLOR=FF0000>Sorry, could not find <B>$t{'test'}</B>.</FONT><BR>Check the file name and try again.</TD></TR>");
   $title = "Error - File Not Found";
   }
   elsif (not(-x "$RootDir$path$t{'test'}")) {
   push(@error,"<TR><TD>$fnt <FONT COLOR=FF0000>Sorry, <B>$t{'test'}</B> is not executable.</FONT><BR>\nSet permissions to 755 or 775 and test again.</TD></TR>");
   $title = "Error - File Not Executable";
   }
  else {
  &runtest;
  }
 }
}
 &result;


##########
# TEST THE SYNTAX

sub runtest {

 @all = `($RootDir$path$t{'test'} | 's/^/stdout:/') 2>&1`;

 for (@all) {push @{s/stdout://?\@outlines: \@errlines},$_}
  if (@errlines) {
   foreach $errline(@errlines) {$qty++;
$errline =~ s/ (at|of) $RootDir$path$t{'test'}//;
$errline =~ s/line /line&nbsp;/;
$errline =~ s/</&#60;/;
$errline =~ s/>/&#62;/;
$errline =~ s/\//&#47;/;
$error = "<TR VALIGN=TOP><TD ALIGN=RIGHT>$fnt1 $qty</TD><TD>$fnt $errline</TD></TR>\n"; push(@error,$error);
  }
}
else {
 push(@error,"<TR><TD>$fnt No errors were found when running <B>$t{'test'}</B></TD></TR>");
 $title = "Congratulations!";
 }
}


##########
# PRINT TEST RESULT

sub result {

&viewDir; 
&form;

print "Content-type: text/html\n\n";

print <<"Error";

<HTML><HEAD><TITLE>TestMy.CGI | $title</TITLE> 

<BODY BGCOLOR=$c4 MARGINWIDTH=12 MARGINHEIGHT=6 LEFTMARGIN=12 RIGHTMARGIN=12 TOPMARGIN=6 BOTTOMMARGIN=6 TEXT=000000 LINK=$c2 ALINK=FF0000 VLINK=$c1 onLoad="document.TestMyCGI.test.focus();"><BASEFONT SIZE=2>$fnt1

$head

<CENTER><TABLE BGCOLOR=$c5 CELLPADDING=9 CELLSPACING=0 BORDER=0><TR ALIGN=CENTER VALIGN=TOP><TD><TABLE BGCOLOR=$c1 CELLPADDING=1 CELLSPACING=0 BORDER=0><TR VALIGN=MIDDLE><TD COLSPAN=3><FONT COLOR=FFFFFF>$fnt1
&nbsp;&#60; <A HREF=\"$t{'testmycgi'}?testmycgi=$t{'testmycgi'}&path=$returnpath&run=yes\" onMouseOver="window.status='return to the parent directory'; return true;" onMouseOut="window.status=''; return true;"><FONT COLOR=FFFFFF>..$returnpath</FONT></A>&nbsp; (return to parent)</TD></TR>
<TR ALIGN=CENTER><TD BGCOLOR=$c3 COLSPAN=3>$fnt1 current&nbsp;path:<BR>
<FONT SIZE=3 FACE="helvetica,arial,sans-serif"><B>$path</B></FONT></TD></TR>
<TR BGCOLOR=$c5 ALIGN=CENTER VALIGN=TOP><TD BGCOLOR=$c5><TABLE BGCOLOR=$c3 CELLPADDING=5 CELLSPACING=0 BORDER=0>
<TR VALIGN=TOP><TD NOWRAP>$fnt<FONT COLOR=$c1><B>DIR</B></FONT><BR>\n$fnt1 $directorydata</TD></TR></TABLE></TD>\n<TD BGCOLOR=$c5 WIDTH=1><IMG SRC="http://www.CraigRichards.com/images/clear.gif" WIDTH=1 HEIGHT=1></TD><TD BGCOLOR=$c5><TABLE BGCOLOR=$c3 CELLPADDING=5 CELLSPACING=0 BORDER=0><TR VALIGN=TOP><TD NOWRAP>
$fnt<FONT COLOR=$c1><B>FILE</B></FONT><BR>
$fnt1 $filedata</TD></TR></TABLE></TD></TR></TABLE>
</TD><TD BGCOLOR=$c5>$fnt
<FONT COLOR=FFFFFF>
$form<P>

<TABLE BGCOLOR=$c1 CELLPADDING=1 CELLSPACING=0 BORDER=0><TR ALIGN=CENTER VALIGN=MIDDLE><TD><FONT SIZE=3 COLOR=FFFFFF FACE="helvetica,arial,sans-serif"><B>$title</B><BR>
<TABLE BGCOLOR=$c4 CELLPADDING=5 CELLSPACING=0 BORDER=0>

@error

</TABLE></TD></TR><TR ALIGN=RIGHT><TD BGCOLOR=$c5 NOWRAP><FONT SIZE=1 COLOR=FFFFFF FACE="arial,helvetica,sans-serif">by <A HREF="http://www.CraigRichards.com/" onMouseOver="window.status='go to Craig Richards Design now'; return true;" onMouseOut="window.status=''; return true;"><FONT COLOR=FFFFFF>Craig Richards Design</FONT></A></TD></TR></TABLE>

</TD></TR></TABLE></CENTER><P>

$foot

Error

}

sub form {

$form = <<"Form";

$fnt1<FORM ACTION="$t{'testmycgi'}" NAME=TestMyCGI METHOD=POST>
<INPUT TYPE=HIDDEN NAME="testmycgi" VALUE="$t{'testmycgi'}">
path&nbsp;<INPUT TYPE=TEXT NAME="path" SIZE=15 MAXLENGTH=100 VALUE="$path"> &nbsp; 

script&nbsp;<INPUT TYPE=TEXT NAME="test" SIZE=15 MAXLENGTH=100 VALUE="$t{'test'}">&nbsp;<INPUT TYPE=SUBMIT NAME="run" VALUE="EXECUTE"></FORM></FONT>

Form

$head = <<"Head";

<TABLE CELLPADDING=9 CELLSPACING=0 BORDER=0><TR VALIGN=TOP><TD WIDTH=100% ALIGN=CENTER NOWRAP>$fnt1<A HREF="http://www.CraigRichards.com/" onMouseOver="window.status='go to Craig Richards Design now'; return true;" onMouseOut="window.status=''; return true;"><IMG SRC="http://www.CraigRichards.com/images/testmycgi96x21.gif" WIDTH=96 HEIGHT=21 ALIGN=MIDDLE BORDER=0 ALT="TestMy.CGI"></A> $version</TD><TD ALIGN=RIGHT NOWRAP>$fnt<FONT SIZE=1 COLOR=909090>TestMy.CGI $version is freeware and may be distributed only in its original form.<BR>
&copy; Copyright 2000 Craig Richards Design. All rights reserved worldwide.
</FONT></TD></TR></TABLE>

$fnt

Head

$foot = "</FONT></BODY></HTML>\n";

}


##########
# SUB REPORT FILES IN DIRECTORY

sub viewDir {

 opendir (DIR, "$RootDir$path");
 @allfiles = grep(!/^\.\.?$/, readdir(DIR));
 foreach $file(@allfiles) {
 if ((-d "$file") || ($file !~ /\./)) {push (@dirs,"&nbsp; <A HREF=\"$t{'testmycgi'}"."?testmycgi=$t{'testmycgi'}&path=$path$file/&run=yes\" onMouseOver=\"window.status='open this directory now'; return true;\" onMouseOut=\"window.status=''; return true;\">$file</A><BR>\n");} # it's a directory
 elsif (-x "$file") {push (@files,"&nbsp; <A HREF=\"$t{'testmycgi'}"."?testmycgi=$t{'testmycgi'}&path=$path&test=$file&run=yes\" onMouseOver=\"window.status='test this script now'; return true;\" onMouseOut=\"window.status=''; return true;\">$file</A><BR>\n");} # it's executable
 elsif (-f "$file") {push (@files,"&nbsp; <! A HREF=\"$t{'testmycgi'}"."?testmycgi=$t{'testmycgi'}&path=$path&test=$file&run=yes\" onMouseOver=\"window.status='test this script now'; return true;\" onMouseOut=\"window.status=''; return true;\">$file</A><BR>\n");} # non-executable file
 else {push (@files,"&nbsp; <A HREF=\"$t{'testmycgi'}"."?testmycgi=$t{'testmycgi'}&path=$path&test=$file&run=yes\" onMouseOver=\"window.status='test this script now'; return true;\" onMouseOut=\"window.status=''; return true;\">$file</A><BR>\n");} # unknown file
 }
	@dirs = sort(@dirs); @files = sort(@files); # alpha sort
 foreach $dirs(@dirs) {$directorydata .= "$dirs";}
 if (!$directorydata) {$directorydata = "&#60;none&#62;";}
 foreach $files(@files) {$filedata .= "$files";}
 if (!$filedata) {$filedata = "&#60;none&#62;";}

$returnpath = "$path";
$returnpath =~ s/(.*)\/(.*)\/$/$1\//;

}


##########
# SUB COMPOSE INSTRUCTION COPY BLOCK

sub instblock {

$instructions = <<"Inst";

<TR VALIGN=TOP><TD>&nbsp;</TD><TD>$fnt <FONT COLOR=$c1><B>TestMy.CGI</B></FONT> allows you to perform testing and error-reporting of your CGI&nbsp;scripts with a simple point-and-click interface. No more command line debugging. No more wading through cryptic error logs for the relevant ones &#150; <FONT COLOR=$c1><B>TestMy.CGI</B></FONT> makes it easy to navigate through your site's various directories then click on the scripts you want to test.</TD></TR>
<TR VALIGN=TOP><TD ALIGN=RIGHT>$fnt1 1.</TD><TD>$fnt Click on the item in the FILE column (left) that you want to test or input the script name after the "script" prompt (above).</TD></TR>
<TR VALIGN=TOP><TD ALIGN=RIGHT>$fnt1 or</TD><TD>$fnt Type the path in the "path" window and type the script name in the "script" window (above). Click the Execute button and the results of the test including an itemized list of errors are reported in this table.</TD></TR>
<TR VALIGN=TOP><TD ALIGN=RIGHT>$fnt1 2.</TD><TD>$fnt If the script you want is not in this directory (<FONT COLOR=FF0000><B>$path</B></FONT>), you can type it after the "path" prompt or navigate to it by clicking down into the directories listed under the DIR column. Return to the parent directory by clicking on the path at the top of the directory contents table. &nbsp; $fnt1 Note: Path is from the domain root &#150; For example, <FONT COLOR=$c1>/cgi-bin/projects/</FONT><P>
Thank you for using <FONT COLOR=$c1><B>TestMy.CGI</B></FONT> and passing it along to your friends and associates.</FONT></TD></TR>

Inst
}


##########
# SUB PARSE

sub inParse {
 $method = $ENV{'REQUEST_METHOD'};
 if ($method =~ /get/i) {
 $buffer = $ENV{'QUERY_STRING'};
 } elsif ($method =~ /post/i) {
  read (STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
 } 

##########
# SPLIT THE NAME/VALUE PAIRS

 @pairs = split(/&/, $buffer);
 foreach $pair(@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	 $t{$name} = $value;
 }
}

1;
exit;
